Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# ACE_Asynch_Write_Stream Class Reference

This class is a factory for starting off asynchronous writes on a stream. This class forwards all methods to its implementation class. More...

`#include <Asynch_IO.h>`

Inheritance diagram for ACE_Asynch_Write_Stream:

[legend]
Collaboration diagram for ACE_Asynch_Write_Stream:

[legend]
List of all members.

## Public Methods
| ACE_Asynch_Write_Stream (void)
| A do nothing constructor. More...
virtual | ~ACE_Asynch_Write_Stream (void)
| Destructor. More...
int | open (ACE_Handler &handler, ACE_HANDLE handle=ACE_INVALID_HANDLE, const void *completion_key=0, ACE_Proactor *proactor=0)
int | write (ACE_Message_Block &message_block, size_t bytes_to_write, const void *act=0, int priority=0, int signal_number=ACE_SIGRTMIN)
int | writev (ACE_Message_Block &message_block, size_t bytes_to_write, const void *act=0, int priority=0, int signal_number=ACE_SIGRTMIN)
ACE_Asynch_Write_Stream_Impl * | implementation (void) const
| Return the underlying implementation class. More...
## Protected Methods
void | implementation (ACE_Asynch_Write_Stream_Impl *implementation)
| Set the implementation class. More...
## Protected Attributes
ACE_Asynch_Write_Stream_Impl * | implementation_
| Implementation class that all methods will be forwarded to. More...

## Detailed Description

This class is a factory for starting off asynchronous writes on a stream. This class forwards all methods to its implementation class.

Once <open> is called, multiple asynchronous <writes>s can started using this class. An ACE_Asynch_Write_Stream::Result will be passed back to the <handler> when the asynchronous write completes through the <ACE_Handler::handle_write_stream> callback.

## Constructor & Destructor Documentation

ACE_Asynch_Write_Stream::ACE_Asynch_Write_Stream | ( | void |  | ) |

| A do nothing constructor.

ACE_Asynch_Write_Stream::~ACE_Asynch_Write_Stream | ( | void |  | ) | `[virtual]`

| Destructor.

## Member Function Documentation

void ACE_Asynch_Write_Stream::implementation | ( | ACE_Asynch_Write_Stream_Impl * | implementation | ) | `[protected]`

| Set the implementation class.

ACE_Asynch_Write_Stream_Impl * ACE_Asynch_Write_Stream::implementation | ( | void |  | ) | const

| Return the underlying implementation class. Reimplemented from ACE_Asynch_Operation. Reimplemented in ACE_Asynch_Write_File.

int ACE_Asynch_Write_Stream::open | ( | ACE_Handler & | handler,
|  | ACE_HANDLE | handle = ACE_INVALID_HANDLE,
|  | const void * | completion_key = 0,
|  | ACE_Proactor * | proactor = 0
| ) |

| Initializes the factory with information which will be used with each asynchronous call. If (<handle> == ACE_INVALID_HANDLE), <ACE_Handler::handle> will be called on the <handler> to get the correct handle. Reimplemented from ACE_Asynch_Operation. Reimplemented in ACE_Asynch_Write_File.

int ACE_Asynch_Write_Stream::write | ( | ACE_Message_Block & | message_block,
|  | size_t | bytes_to_write,
|  | const void * | act = 0,
|  | int | priority = 0,
|  | int | signal_number = ACE_SIGRTMIN
| ) |

| This starts off an asynchronous write. Upto <bytes_to_write> will be written from the <message_block>. Upon successful completion of the write operation, <message_block>'s <rd_ptr> is updated to reflect the data that was written. Priority of the operation is specified by <priority>. On POSIX4-Unix, this is supported. Works like <nice> in Unix. Negative values are not allowed. 0 means priority of the operation same as the process priority. 1 means priority of the operation is one less than process. And so forth. On Win32, this argument is a no-op. <signal_number> is the POSIX4 real-time signal number to be used for the operation. <signal_number> ranges from ACE_SIGRTMIN to ACE_SIGRTMAX. This argument is a no-op on non-POSIX4 systems.

int ACE_Asynch_Write_Stream::writev | ( | ACE_Message_Block & | message_block,
|  | size_t | bytes_to_write,
|  | const void * | act = 0,
|  | int | priority = 0,
|  | int | signal_number = ACE_SIGRTMIN
| ) |

| Same as above but with gather support, through chaining of composite message blocks using the continuation field.

## Member Data Documentation

ACE_Asynch_Write_Stream_Impl* ACE_Asynch_Write_Stream::implementation_`[protected]`

| Implementation class that all methods will be forwarded to. Reimplemented from ACE_Asynch_Operation. Reimplemented in ACE_Asynch_Write_File.

The documentation for this class was generated from the following files:

- Asynch_IO.h
- Asynch_IO.cpp